module Musicality
module Instruments
  DEFAULT_INSTRUMENT = ACOUSTIC_GRAND_PIANO = Instrument.treble_bass("Acoustic Grand Piano", 1)
  BRIGHT_ACOUSTIC_PIANO = Instrument.treble_bass("Bright Acoustic Piano", 2)
  ELECTRIC_GRAND_PIANO = Instrument.treble_bass("Electric Grand Piano", 3)
  HONKY_TONK_PIANO = Instrument.treble_bass("Honky Tonk Piano", 4)
  ELECTRIC_PIANO_1 = Instrument.treble_bass("Electric Piano", 5)
  ELECTRIC_PIANO_2 = Instrument.treble_bass("Electric Piano", 6)
  HARPSICHORD = Instrument.treble_bass("Harpsichord", 7)
  CLAVINET = Instrument.treble_bass("Clavinet", 8)
  CELESTA = Instrument.treble_bass("Celesta", 9, -12)

  GLOCKENSPIEL = Instrument.treble_bass("Glockenspiel", 10, -24)
  MUSIC_BOX = Instrument.treble_bass("Music Box", 11)
  VIBRAPHONE = Instrument.treble_bass("Virbaphone",12)
  MARIMBA = Instrument.treble_bass("Marimba",13)
  XYLOPHONE = Instrument.treble_bass("Xylophone",14, -12)
  TUBULAR_BELLS = Instrument.treble_bass("Tubular Bells",15)
  DULCIMER = Instrument.treble("Dulcimer",16)

  DRAWBAR_ORGAN = Instrument.treble_bass("Drawbar Organ", 17)
  PERCUSSIVE_ORGAN = Instrument.treble_bass("Percussive Organ", 18)
  ROCK_ORGAN = Instrument.treble_bass("Rock Organ", 19)
  CHURCH_ORGAN = Instrument.treble_bass("Church Organ", 20)
  REED_ORGAN = Instrument.treble_bass("Reed Organ", 21)
  ACCORDIAN = Instrument.treble_bass("Accordion", 22)
  HARMONICA = Instrument.treble("Harmonica", 23)
  TANGO_ACCORDIAN = Instrument.treble_bass("Tango Accordion", 24)

  ACOUSTIC_GUITAR_NYLON = Instrument.guitar('Acoustic Guitar (nylon)', 25)
  ACOUSTIC_GUITAR_STEEL = Instrument.guitar('Acoustic Guitar (steel)', 26)
  ELECTRIC_GUITAR_JAZZ = Instrument.guitar('Electric Guitar (jazz)', 27)
  ELECTRIC_GUITAR_CLEAN = Instrument.guitar('Electric Guitar (clean)', 28)
  ELECTRIC_GUITAR_MUTED = Instrument.guitar('Electric Guitar (muted)', 29)
  OVERDRIVEN_GUITAR = Instrument.guitar('Overdriven Guitar', 30)
  DISTORTION_GUITAR = Instrument.guitar('Distortion Guitar', 31)
  GUITAR_HARMONICS = Instrument.guitar('Guitar Harmonics', 32)
  
  ACOUSTIC_BASS = Instrument.bass_guitar('Acoustic Bass', 33)
  ELECTRIC_BASS_FINGER = Instrument.bass_guitar('Electric Bass (finger)', 34)
  ELECTRIC_BASS_PICK = Instrument.bass_guitar('Electric Bass (pick)', 35)
  FRETLESS_BASS = Instrument.bass_guitar('Fretless Bass', 36)
  SLAP_BASS_1 = Instrument.bass_guitar('Slap Bass', 37)
  SLAP_BASS_2 = Instrument.bass_guitar('Slap Bass', 38)
  SYNTH_BASS_1 = Instrument.bass_guitar('Synth Bass', 39)
  SYNTH_BASS_2 = Instrument.bass_guitar('Synth Bass', 40)

  VIOLIN = Instrument.treble('Violin', 41)
  VIOLA = Instrument.treble_alto('Viola', 42)
  CELLO = Instrument.tenor_bass('Cello', 43)
  CONTRABASS = Instrument.bass('Contrabass', 44, 12)
  TREMOLO_STRINGS = Instrument.treble_bass('Tremolo Strings', 45)
  PIZZICATO_STRINGS = Instrument.treble_bass('Pizzicato Strings', 46)
  ORCHESTRAL_HARP = Instrument.treble_bass('Orchestral Harp', 47)
  TIMPANI = Instrument.bass('Timpani', 48)
  STRING_ENSEMBLE_1 = Instrument.treble_bass('String Ensemble', 49)
  STRING_ENSEMBLE_2 = Instrument.treble_bass('String Ensemble', 50)
  SYNTH_STRINGS_1 = Instrument.treble_bass('Synth Strings', 51)
  SYNTH_STRINGS_2 = Instrument.treble_bass('Synth Strings', 52)
  
  CHOIR_AAHS = Instrument.treble_bass('Choir Aahs', 53)
  VOICE_OOHS = Instrument.treble_bass('Voice Oohs', 54)
  SYNTH_VOICE = Instrument.treble_bass('Synth Voice', 55)
  ORCHESTRA_HIT = Instrument.treble_bass('Orchestra Hit', 56)
  
  TRUMPET = Instrument.treble('Trumpet', 57, 2)
  TROMBONE = Instrument.tenor_bass('Trombone', 58)
  TUBA = Instrument.bass('Tuba', 59)
  MUTED_TRUMPET = Instrument.treble('Muted Trumpet', 60)
  FRENCH_HORN = Instrument.bass('French Horn', 61)
  BRASS_SECTION = Instrument.treble_bass('Brass Section', 62)
  SYNTH_BRASS_1 = Instrument.treble_bass('Synth Brass', 63)
  SYNTH_BRASS_2 = Instrument.treble_bass('Synth Brass', 64)
  
  SOPRANO_SAX = Instrument.treble('Soprano Sax', 65, 2)
  ALTO_SAX = Instrument.treble('Alto Sax', 66, 9)
  TENOR_SAX = Instrument.treble('Tenor Sax', 67, 14)
  BARITONE_SAX = Instrument.treble('Baritone Sax', 68, 21)
  OBOE = Instrument.treble('Oboe', 69)
  ENGLISH_HORN = Instrument.treble('English Horn', 70, 7)
  BASSOON = Instrument.bass('Bassoon', 71)
  CLARINET = Instrument.treble('Clarinet', 72, 2)
  
  PICCOLO = Instrument.treble('Piccolo', 73, -12)
  FLUTE = Instrument.treble('Flute', 74)
  RECORDER = Instrument.treble('Recorder', 75)
  PAN_FLUTE = Instrument.treble_bass('Pan Flute', 76)
  BLOWN_BOTTLE = Instrument.treble_bass('Blown Bottle', 77)
  SHAKUHACHI = Instrument.treble_bass('Shakuhachi', 78)
  WHISTLE = Instrument.treble_bass('Whistle', 79)
  OCARINA = Instrument.treble_bass('Ocarina', 80)
  
  LEAD_SQUARE = Instrument.treble_bass('Lead (square)', 81)
  LEAD_SAWTOOTH = Instrument.treble_bass('Lead (sawtooth)', 82)
  LEAD_CALLIOPE = Instrument.treble_bass('Lead (calliope)', 83)
  LEAD_CHIFF = Instrument.treble_bass('Lead (chiff)', 84)
  LEAD_CHARANG = Instrument.treble_bass('Lead (charang)', 85)
  LEAD_VOICE = Instrument.treble_bass('Lead (voice)', 86)
  LEAD_FIFTHS = Instrument.treble_bass('Lead (fifths)', 87)
  LEAD_PLUS_BASS = Instrument.treble_bass('Lead (bass+lead)', 88)
  
  PAD_NEW_AGE = Instrument.treble_bass('Pad (new age)', 89)
  PAD_WARM = Instrument.treble_bass('Pad (warm)', 90)
  PAD_POLYSYNTH = Instrument.treble_bass('Pad (polysynth)', 91)
  PAD_CHOIR = Instrument.treble_bass('Pad (choir)', 92)
  PAD_BOWED = Instrument.treble_bass('Pad (bowed)', 93)
  PAD_METALLIC = Instrument.treble_bass('Pad (metallic)', 94)
  PAD_HALO = Instrument.treble_bass('Pad (halo)', 95)
  PAD_SWEEP = Instrument.treble_bass('Pad (sweep)', 96)
end
end
